### Installation

#### Add Apache Virtual Host

```
Listen 443

<VirtualHost *:443>
	ServerName ldap.loc
	ServerAdmin webmaster@localhost
	DocumentRoot /path/to/ldap/public

	ErrorLog ${APACHE_LOG_DIR}/error.log
	CustomLog ${APACHE_LOG_DIR}/access.log combined

	#SSL certificates config should be here
</VirtualHost>
```

#### Run post install script

```cd /path/to/ldap; sh scripts/post-install.sh```

#### Configuration

To edit ldap config manually use file - ```/path/to/ldap/config/settings.ldap.php```

##### Useful info

Config backups here - ```/path/to/ldap/config/config_dump```

Change logging levels in ```config/settings.php```

By default logs go in ```../../logs/ldap_log``` so that in production they end up in ```/var/cfengine/httpd/logs/ldap_log```
